---
title: RTCIceCandidatePairStats
slug: Web/API/RTCIceCandidatePairStats
tags:
  - API
  - Candidate
  - Candidate Pair
  - Connection
  - Connectivity
  - Dictionary
  - ICE
  - Media
  - Networking
  - Pair
  - Reference
  - Statistics
  - Stats
  - WebRTC
  - WebRTC API
  - candidate-pair
  - rtc
---
<p>{{APIRef("WebRTC")}}</p>

<p><span class="seoSummary">The WebRTC <code><strong>RTCIceCandidatePairStats</strong></code> dictionary reports statistics which provide insight into the quality and performance of an {{domxref("RTCPeerConnection")}} while connected and configured as described by the specified pair of {{Glossary("ICE")}} candidates.</span></p>

<p>If a {{domxref("RTCStats")}}-based object's {{domxref("RTCStats.type", "type")}} is <code>candidate-pair</code>, it's an <code>RTCIceCandidatePairStats</code> object.</p>

<h2 id="Properties">Properties</h2>

<p><em><code>RTCIceCandidatePairStats</code> is based upon {{domxref("RTCStats")}} and inherits its properties. In addition, it adds the following new properties:</em></p>

<dl>
 <dt>{{domxref("RTCIceCandidatePairStats.availableIncomingBitrate", "availableIncomingBitrate")}} {{optional_inline}}</dt>
 <dd>Provides an informative value representing the available inbound capacity of the network by reporting the total number of bits per second available for all of the candidate pair's incoming {{Glossary("RTP")}} streams. This does not take into account the size of the {{Glossary("IP")}} overhead, nor any other transport layers such as {{Glossary("TCP")}} or {{Glossary("UDP")}}.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.availableOutgoingBitrate", "availableOutgoingBitrate")}} {{optional_inline}}</dt>
 <dd>Provides an informative value representing the available outbound capacity of the network by reporting the total number of bits per second available for all of the candidate pair's outoing {{Glossary("RTP")}} streams. This does not take into account the size of the {{Glossary("IP")}} overhead, nor any other transport layers such as {{Glossary("TCP")}} or {{Glossary("UDP")}}.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.bytesReceieved", "bytesReceieved")}} {{optional_inline}}</dt>
 <dd>The total number of payload bytes received (that is, the total number of bytes received minus any headers, padding, or other administrative overhead) on this candidate pair so far.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.bytesSent", "bytesSent")}} {{optional_inline}}</dt>
 <dd>The total number of payload bytes sent (that is, the total number of bytes sent minus any headers, padding, or other administrative overhead) so far on this candidate pair.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.circuitBreakerTriggerCount", "circuitBreakerTriggerCount")}} {{optional_inline}}</dt>
 <dd>An integer value indicating the number of times the circuit-breaker has been triggered for this particular 5-tuple (the set of five values comprising a TCP connection: source IP address, source port number, destination IP address, destination port number, and protocol). The circuit breaker is triggered whenever a connection times out or otherwise needs to be automatically aborted.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.consentExpiredTimestamp", "consentExpiredTimestamp")}} {{optional_inline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} value indicating the time at which the most recent STUN binding response expired. This value is <code>undefined</code> if no valid STUN binding responses have been sent on the candidate pair; this can only happen if {{domxref("RTCIceCandidatePairStats.responsesReceived", "responsesReceived")}} is 0.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.consentRequestsSent", "consentRequestsSent")}} {{optional_inline}}</dt>
 <dd>The total number of consent requests that have been sent on this candidate pair.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.currentRoundTripTime", "currentRoundTripTime")}} {{optional_inline}}</dt>
 <dd>A floating-point value indicating the total time, in seconds, that elapsed between the most recently-sent STUN request and the response being received. This may be based upon requests that were involved in confirming permission to open the connection.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.firstRequestTimestamp", "firstRequestTimestamp")}} {{optional_inline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} value which specifies the time at which the first STUN request was sent from the local peer to the remote peer for this candidate pair.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.lastPacketReceivedTimestamp", "lastPacketReceivedTimestamp")}} {{optional_inline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} value indicating the time at which the last packet was received by the local peer from the remote peer for this candidate pair. Timestamps are not recorded for STUN packets.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.lastPacketSentTimestamp", "lastPacketSentTimestamp")}} {{optional_inline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} value indicating the time at which the last packet was sent from the local peer to the remote peer for this candidate pair. Timestamps are not recorded for STUN packets.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.lastRequestTimestamp", "lastRequestTimestamp")}} {{optional_inline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} value which specifies the time at which the last (most recent) STUN request was sent from the local peer to the remote peer for this candidate pair.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.lastResponseTimestamp", "lastResponseTimestamp")}} {{optional_inline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} value that specifies the time at which the last (most recent) STUN response was received by the local candidate from the remote candidate in this pair.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.localCandidateId", "localCandidateId")}} {{optional_inline}}</dt>
 <dd>The unique ID string corresponding to the {{domxref("RTCIceCandidate")}} from the data included in the {{domxref("RTCIceCandidateStats")}} object providing statistics for the candidate pair's local candidate.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.nominated", "nominated")}} {{optional_inline}}</dt>
 <dd>A Boolean value which, if <code>true</code>, indicates that the candidate pair described by this object is one which has been proposed for use, and will be (or was) used if its priority is the highest among the nominated candidate pairs. See {{RFC(5245, "", "7.1.3.2.4")}} for details.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.packetsReceived", "packetsReceived")}} {{optional_inline}}</dt>
 <dd>The total number of packets received on this candidate pair.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.packetsSent", "packetsSent")}} {{optional_inline}}</dt>
 <dd>The total number of packets sent on this candidate pair.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.remoteCandidateId", "remoteCandidateId")}} {{optional_inline}}</dt>
 <dd>The unique ID string corresponding to the remote candidate from which data was taken to construct the <code>RTCIceCandidateStats</code> object describing the remote end of the connection.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.requestsReceived", "requestsReceived")}} {{optional_inline}}</dt>
 <dd>The total number of connectivity check requests that have been received, including retransmissions. This value includes both connectivity checks and STUN consent checks.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.requestsSent", "requestsSent")}} {{optional_inline}}</dt>
 <dd>The total number of connectivity check requests that have been sent, <em>not</em> including retransmissions.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.responsesReceived", "responsesReceived")}} {{optional_inline}}</dt>
 <dd>The total number of connectivity check responses that have been received.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.responsesSent", "responsesSent")}} {{optional_inline}}</dt>
 <dd>The total number of connectivity check responses that have been sent. This includes both connectivity check requests and STUN consent requests.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.retransmissionsReceived", "retransmissionsReceived")}} {{optional_inline}}</dt>
 <dd>The total number of times connectivity check request retransmissions were received. A retransmission is a connectivity check request whose <code>TRANSACTION_TRANSMIT_COUNTER</code> attribute's <code>req</code> field is greater than 1.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.retransmissionsSent", "retransmissionsSent")}} {{optional_inline}}</dt>
 <dd>The total number of times connectivity check request retransmissions were sent.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.state", "state")}} {{optional_inline}}</dt>
 <dd>A {{domxref("RTCStatsIceCandidatePairState")}} object which indicates the state of the connection between the two candidates.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.totalRoundTripTime", "totalRoundTripTime")}} {{optional_inline}}</dt>
 <dd>A floating-point value indicating the total time, in seconds, that has elapsed between sending STUN requests and receiving responses to them, for all such requests made to date on this candidate pair. This includes botyh connectivity check and consent check requests. You can compute the average round trip time (RTT) by dividing this value by {{domxref("RTCIceCandidatePairStats.responsesReceived", "responsesReceived")}}.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.transportId", "transportId")}} {{optional_inline}}</dt>
 <dd>A {{domxref("DOMString")}} that uniquely identifies the {{domxref("RTCIceTransport")}} that was inspected to obtain the transport-related statistics (as found in {{domxref("RTCTransportStats")}}) used in generating this object.</dd>
</dl>

<h3 id="Obsolete_properties">Obsolete properties</h3>

<p>The following properties have been removed from the specification and should no longer be used. You should update any existing code to avoid using them as soon as is practical. Check the {{anch("Browser compatibility", "compatibility table")}} for details on which browsers support them and in which versions.</p>

<dl>
 <dt>{{domxref("RTCIceCandidatePairStats.priority", "priority")}} {{obsolete_inline}} {{optional_inline}}</dt>
 <dd>An integer value indicating the candidate pair's priority.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.readable", "readable")}} {{obsolete_inline}} {{optional_inline}}</dt>
 <dd>A Boolean value indicating whether or not data can be sent over the connection described by the candidate pair.</dd>
 <dt>{{domxref("RTCIceCandidatePairStats.writable", "writable")}} {{obsolete_inline}} {{optional_inline}}</dt>
 <dd>A Boolean value indicating whether or not data can be received on the connection described by the candidate pair.</dd>
</dl>

<h3 id="Non-standard_properties">Non-standard properties</h3>

<dl>
 <dt>{{domxref("RTCIceCandidatePairStats.selected", "selected")}} {{non-standard_inline}} {{optional_inline}}</dt>
 <dd>A Firefox-specific Boolean value which is <code>true</code> if the candidate pair described by this object is the one currently in use. The spec-compliant way to determine the selected candidate pair is to look for a stats object of type <code>transport</code>, which is an {{domxref("RTCTransportStats")}} object. That object's {{domxref("RTCTransportStats.selectedCandidatePairId", "selectedCandidatePairId")}} property indicates whether or not the specified transport is the one being used.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>The currently-active ICE candidate pair—if any—can be obtained by calling the {{domxref("RTCIceTransport")}} method {{domxref("RTCIceTransport.getSelectedCandidatePair", "getSelectedCandidatePair()")}}, which returns an {{domxref("RTCIceCandidatePair")}} object, or <code>null</code> if there isn't a pair selected. The active candidate pair describes the current configuration of the two ends of the {{domxref("RTCPeerConnection")}}.</p>

<p>Any candidate pair that isn't the active pair of candidates for a transport gets deleted if the {{domxref("RTCIceTransport")}} performs an ICE restart, at which point the {{domxref("RTCIceTransport.state", "state")}} of the ICE transport returns to <code>new</code> and negotiation starts once again. For more information, see {{SectionOnPage("/en-US/docs/Web/API/WebRTC_API/Session_lifetime", "ICE restart")}}.</p>

<h2 id="Example">Example</h2>

<p>This example computes the average time elapsed between connectivity checks if the {{domxref("RTCStats")}} object <code>rtcStats</code> is an <code>RTCIceCandidatePairStats</code> object.</p>

<pre class="brush: js">if (rtcStats &amp;&amp; rtcStats.type === "candidate-pair") {
  let elapsed = (rtcStats.lastRequestTimestamp - rtcStats.firstRequestTimestamp)
                  / rtcStats.requestsSent;

  log("Average time between ICE connectivity checks: " + elapsed + " ms.");
}
</pre>

<p>The code begins by looking at <code>rtcStats</code> to see if its {{domxref("RTCStats.type", "type")}} is <code>candidate-pair</code>. If it is, then we know that <code>rtcStats</code> is in fact an {{domxref("RTCIceCandidatePairStats")}} object. If so, we compute the average time elapsed between STUN connectivity checks and log that information.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC Statistics Identifiers', '#dom-rtcicecandidatepairstats', 'RTCIceCandidatePairStats') }}</td>
   <td>{{ Spec2('WebRTC Statistics Identifiers') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCIceCandidatePairStats")}}</p>
